// $Id: cookbook-front.js,v 1.3.2.13 2011/02/04 10:22:52 icc Exp $

/**
 * Changes the random recipe on the front page.
 */
var CookbookFront = {
  /**
   * Initialize the front page.
   */
  init: function() {
    // Click on random recipe overlay
    $('#recipes div.overlay')

    var $recipes = $('#recipes');
    CookbookFront.$overlay = $('.overlay', $recipes)
    CookbookFront.$image = $('.image', $recipes);
    CookbookFront.$header = $('h3', CookbookFront.$overlay);
    CookbookFront.$link = $('a', CookbookFront.$overlay);
    CookbookFront.$overlay.click(function() {
      window.location = CookbookFront.$link.attr('href');
    });

    CookbookFront.recipe = CookbookFront.$link.attr('href').match(/\d+$/);
    CookbookFront.fetch();
  },

  /**
   * Fetch random recipes.
   */
  fetch: function() {
    $.getJSON(Drupal.settings['cookbook']['url'] + '/xhr/random', function(data) {
      CookbookFront.recipes = data;
      if (data.length > 1) {
        setInterval(CookbookFront.changeRecipe, 10000);
      }
    });
  },

  /**
   * Change to random recipe.
   */
  changeRecipe: function() {
    // Pick random recipe
    var i = Math.floor(Math.random() * CookbookFront.recipes.length);

    // Make sure it's not the same as last time.
    if (CookbookFront.recipes[i]['nid'] == CookbookFront.recipe) {
      CookbookFront.changeRecipe();
      return;
    }
    CookbookFront.recipe = CookbookFront.recipes[i]['nid']

    var $newImage = CookbookFront.$image.children().clone().appendTo(CookbookFront.$image).hide().attr('src', CookbookFront.recipes[i]['image']);
    CookbookFront.$overlay.fadeOut('fast', function() {
      $newImage.prev().fadeOut('fast', function() {
        $(this).remove();
        CookbookFront.$header.html(CookbookFront.recipes[i]['title']);
        CookbookFront.$link.attr('href', CookbookFront.$link.attr('href').replace(/\d+$/, CookbookFront.recipes[i]['nid']));

        // Show new recipe
        if ($newImage[0].complete) {
          // Image is cached
          $newImage.fadeIn('slow', function() {
            CookbookFront.$overlay.fadeIn('fast');
          });
        }
        else {
          $newImage.load(function() {
            // Image loaded
            $newImage.fadeIn('slow', function() {
              CookbookFront.$overlay.fadeIn('fast');
            });
          });
        }
      });
    });
  }
}

$(document).ready(CookbookFront.init);